unit Unit4;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ExtCtrls,
  UnitV ;

type
  TForm4 = class(TForm)
    SG1: TStringGrid;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Panel1: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label2: TLabel;
    ComboBox1: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SG1Click(Sender: TObject);
    procedure Edit1DblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
    procedure TableDisplay ;
  public
    { Public 錾 }
  end;

var
  Form4: TForm4;

implementation

uses
   Unit1 ;

{$R *.dfm}

// N
procedure TForm4.FormShow(Sender: TObject);
var
   i,n : integer ;
   s : array of string ;
begin
   with SG1 do begin
      RowCount := 2 ;
      Cells[0,0] := 'ԍ';
      Cells[1,0] := 'No';
      Cells[2,0] := '';
      Cells[3,0] := '';
      for i:=0 to ColCount-1 do
         Cells[i,1] := '' ;
   end;
   if (Trim(DBfold) = '')or(Trim(DBname) = '') then begin
      ShowMessage('ŏɃf[^x[X̐ݒsĉB');
      close ;
      exit ;
   end;
   // ڑ`FbNiꉞj
   if not(Form1.IBDatabase1.Connected) then begin
      ShowMessage('f[^x[Xɐڑo܂BݒmFĉB');
      close ;
      exit ;
   end;
   // e[u Form1 ĂяoOɍ쐬ς

   // (SECTION)e[uComboBox1
   ComboBox1.Items.Clear ;
   ComboBox1.Items.Add('0:w薳');
   if (Form1.DataTableCheck(TABLE1)) then begin
      n := Form1.TableRef('*',TABLE1,'','N');
      SetLength(s,TABLE1N);
      for i:=1 to n do begin
         if (i = 1) then
            Form1.TableFirst(s)
         else
            Form1.TableNext(s);
         ComboBox1.Items.Add(s[0]+':'+s[1]);
      end;
      Form1.TableClose ;
      s := nil;
   end;
   ComboBox1.ItemIndex := 0 ;
   
   // e[uQƁEꗗ\
   TableDisplay ;

   SG1.SetFocus ;
end;

// I
procedure TForm4.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   //
end;

// e[uQƁEꗗ\
procedure TForm4.TableDisplay ;
var
   i,j,m,n : integer ;
   p,t,w : string ;
   s : array of string ;
begin
   SG1.RowCount := 2 ;
   for i:=0 to SG1.ColCount-1 do
      SG1.Cells[i,1] := '' ;

   p := TABLE2+'.N,' + TABLE2+'.SN,' + TABLE1+'.SNAME,' + TABLE2+'.PNAME' ;
   t := TABLE2 + ',' + TABLE1 ;
   w := TABLE2 + '.SN=' + TABLE1 + '.N OR ' + TABLE2 + '.SN=0' ;
   n := Form1.TableRef(p,t,w,TABLE2+'.N');
   if (n > 0) then begin
      SetLength(s,4);

      m := 0;
      for i:=1 to n do begin
         Inc(m);
         with SG1 do begin
            if (i = 1) then
               Form1.TableFirst(s)
            else
               Form1.TableNext(s);
            if (SInt(s[1]) = 0) then s[2] := '';
            for j:=0 to 3 do
               Cells[j,m] := s[j] ;
            // w(SN=0)̏ꍇAsƂȂĂ܂̂
            // OƓԍ̏ꍇɂ͍sǉȂ悤ɂĂ
            // iwȂꍇ́Â悤ȎsKv͂Ȃj
            if (m > 1) then
               if (SInt(Cells[0,m]) = SInt(Cells[0,m-1])) then
                  Dec(m);
            RowCount := m+1 ;
        end;
      end;
      Form1.TableClose ;

      s := nil;
   end;
end;

// \NbN
procedure TForm4.SG1Click(Sender: TObject);
var
   i,j : integer ;
   s : string ;
begin
   i := SG1.Row ;
   s := SG1.Cells[0,i] ;
   if (s = '') then exit ;
   Edit1.Text := s ;
   Edit2.Text := SG1.Cells[3,i] ;
   j := SInt(SG1.Cells[1,i]);
   if (j < 0)or(j > ComboBox1.Items.Count) then j := 0;
   ComboBox1.ItemIndex := j ;
end;

// ԍŃ_uNbNŏIԍ+1
procedure TForm4.Edit1DblClick(Sender: TObject);
var
   n : integer ;
begin
   n := SInt(Form1.GetMaxValue(TABLE2,'N',''));
   Edit1.Text := IntToStr(n+1);
end;

// o^
procedure TForm4.Button1Click(Sender: TObject);
var
   n,sn,i : integer ;
   fs: array of string ;
   s : array of string ;
begin
   if (Trim(Edit1.Text) = '') then begin
      ShowMessage('ԍ͂ĉi̐ĺj');
      Edit1.SetFocus ;
      exit ;
   end;
   n := SInt(Edit1.Text) ;
   if (n <= 0) then begin
      ShowMessage('ԍ͐̐œ͂ĉ');
      Edit1.SetFocus ;
      exit ;
   end;
   sn := ComboBox1.ItemIndex ;

   SetLength(fs,TABLE2N);
   SetLength(s ,TABLE2N);

   fs[0] := 'N';
   fs[1] := 'SN';
   fs[2] := 'PNAME';

   s[0] := IntToStr(n) ;
   s[1] := IntToStr(sn) ;
   s[2] := Edit2.Text ;

   for i:=2 to 2 do begin
      if (AnsiPos('''',s[i]) > 0) or (AnsiPos('"',s[i]) > 0) then begin
         fs := nil ;
         s  := nil ;
         ShowMessage('pu''vu"v͂Ȃŉ');
         Edit2.SetFocus;
         exit;
      end;
   end;
   for i:=2 to 2 do begin
      if (s[i] = '') then
         s[i] := 'NULL'
      else
         s[i] := '''' + s[i] + '''' ;
   end;

   if (Form1.TableAdd(TABLE2,TABLE2N,fs,s)) then begin
      ShowMessage('o^OK');
   end
   else begin
      ShowMessage('o^s');
   end;

   fs := nil ;
   s  := nil ;

   TableDisplay ;
end;

// 폜
procedure TForm4.Button2Click(Sender: TObject);
var
   i : integer ;
   s : string ;
begin
   i := SG1.Row ;
   s := SG1.Cells[0,i] ;
   if (s = '') then exit ;
   s := 'No.' + s + 'F' + SG1.Cells[3,i] ;
   if MessageDlg('u'+s+'v폜܂B' + #13 + #10 + '낵łH',
      mtConfirmation, [mbYes, mbNo], 0) = mrNo then exit ;
   //
   s := SG1.Cells[0,i] ;
   i := SInt(s);
   if (Form1.TableDel(TABLE2,'N='+IntToStr(i))) then begin
      ShowMessage('폜OK');
   end
   else begin
      ShowMessage('폜s');
   end;
   //
   TableDisplay ;
end;

// 
procedure TForm4.Button3Click(Sender: TObject);
begin
   close;
end;

// ύX
procedure TForm4.Button4Click(Sender: TObject);
var
   n,sn,i : integer ;
   fs: array of string ;
   s : array of string ;
   w : string ;
begin
   if (Trim(Edit1.Text) = '') then begin
      ShowMessage('ԍ͂ĉi̐ĺj');
      Edit1.SetFocus ;
      exit ;
   end;
   if (Trim(Edit2.Text) = '') then begin
      ShowMessage('͂ĉip16܂Łj');
      Edit2.SetFocus ;
      exit ;
   end;
   n := SInt(Edit1.Text) ;
   if (n <= 0) then begin
      ShowMessage('ԍ͐̐œ͂ĉ');
      Edit1.SetFocus ;
      exit ;
   end;
   sn := ComboBox1.ItemIndex ;
   //
   // f[^`FbN
   if not(Form1.CheckValue(TABLE2,'N','', n)) then begin
      ShowMessage('͂ԍ͖gpł̂ŕύX͏o܂Bē͂ĉ');
      Edit1.SetFocus ;
      exit ;
   end ;
   //
   SetLength(fs,TABLE2N);
   SetLength(s ,TABLE2N);

   fs[0] := 'N';
   fs[1] := 'SN';
   fs[2] := 'PNAME';

   s[0] := IntToStr(n) ;
   s[1] := IntToStr(sn) ;
   s[2] := Edit2.Text ;

   for i:=2 to 2 do begin
      if (AnsiPos('''',s[i]) > 0) or (AnsiPos('"',s[i]) > 0) then begin
         fs := nil ;
         s  := nil ;
         ShowMessage('pu''vu"v͂Ȃŉ');
         Edit2.SetFocus;
         exit;
      end;
   end;
   for i:=2 to 2 do begin
      if (s[i] = '') then
         s[i] := 'NULL'
      else
         s[i] := '''' + s[i] + '''' ;
   end;

   w := 'N=' + IntToStr(n) ;

   if (Form1.TableEdit(TABLE2,TABLE2N,fs,s,w)) then begin
      ShowMessage('ύXOK');
   end
   else begin
      ShowMessage('ύXs');
   end;

   fs := nil ;
   s  := nil ;

   TableDisplay ;
end;

end.
